// PrintPreviewView.cpp : implementation of the CPrintPreviewView class
//

#include "stdafx.h"
#include "PrintPreview.h"

#include "PrintPreviewDoc.h"
#include "PrintPreviewView.h"

#include "MyPreviewView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrintPreviewView

IMPLEMENT_DYNCREATE(CPrintPreviewView, CEditView)

BEGIN_MESSAGE_MAP(CPrintPreviewView, CEditView)
	//{{AFX_MSG_MAP(CPrintPreviewView)
	ON_COMMAND(ID_FILE_IMPROVEDPRINTPREVIEW, OnFileImprovedprintpreview)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrintPreviewView construction/destruction

CPrintPreviewView::CPrintPreviewView()
{
	// TODO: add construction code here

}

CPrintPreviewView::~CPrintPreviewView()
{
}

BOOL CPrintPreviewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	BOOL bPreCreated = CEditView::PreCreateWindow(cs);
	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// Enable word-wrapping

	return bPreCreated;
}

/////////////////////////////////////////////////////////////////////////////
// CPrintPreviewView drawing

void CPrintPreviewView::OnDraw(CDC* pDC)
{
	UNUSED(pDC);

	CPrintPreviewDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CPrintPreviewView printing

BOOL CPrintPreviewView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default CEditView preparation
	return CEditView::OnPreparePrinting(pInfo);
}

void CPrintPreviewView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView begin printing.
	CEditView::OnBeginPrinting(pDC, pInfo);
}

void CPrintPreviewView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView end printing
	CEditView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CPrintPreviewView diagnostics

#ifdef _DEBUG
void CPrintPreviewView::AssertValid() const
{
	CEditView::AssertValid();
}

void CPrintPreviewView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CPrintPreviewDoc* CPrintPreviewView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPrintPreviewDoc)));
	return (CPrintPreviewDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPrintPreviewView message handlers

void CPrintPreviewView::OnFileImprovedprintpreview() 
{
	// need to use CMyPreviewView class
	CPrintPreviewState* pState = new CPrintPreviewState;

	if (!DoPrintPreview(IDD_PREVIEW, this, RUNTIME_CLASS(CMyPreviewView), pState))
	{
		TRACE0("Error: OnFileImprovedprintpreview failed.\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		delete pState;      // preview failed to initialize, delete State now
	}
}
